<?php

namespace Odhen\API\Service;

use \Util\Exception;

class POSCurl {
    protected $entityManager;
    protected $util;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager, \Odhen\API\Util\Util $util){
        $this->util = $util;
        $this->entityManager = $entityManager;
    }

    public function makeCurl($URL, $isPost, $headers, $body) {
        $method = $isPost ? 'POST' : 'GET';
        $body = $body->saveXML();
        $curl = curl_init();

        curl_setopt($curl, CURLOPT_URL, $URL);

        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);

        curl_setopt($curl, CURLOPT_POST, $isPost);
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, $method);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $body);

        curl_setopt($curl, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_TIMEOUT, 20);
        curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);

        $curl_response = curl_exec($curl);
        $err    = curl_errno($curl);
        $errmsg = curl_error($curl);
        curl_close($curl);

        // var_dump($body);
        // var_dump($curl_response);
        // var_dump($err);
        // var_dump($errmsg);
        // die;

        if (!empty($err)){
            throw new \Exception("<br>Erro ao conectar com a api.<br><br>". $errmsg);
        } /*else if (empty($curl_response)){
            throw new \Exception("<br>Não houve retorno da api.");
        }*/ else if(isset($curl_response["status"]) && $curl_response["status"] != true){
            throw new \Exception("<br>Erro na requisição: <br>" . $curl_response["message"]);
        }

        // return $curl_response;
        return simplexml_load_string($curl_response);
    }
}