function IntegrationStone(PaymentRepository, ScreenService, WindowService, templateManager){

    var self = this;
    var PAYMENT_CONFIRMATION = false;
    var REMOVE_ALL_INTEGRATIONS = false;
    var MESSAGE_INTEGRATION_FAIL = 'Não foi possível chamar a integração. Sua instância não existe.';

    var PAYMENTSTATUS_COMPLETED = '1';
    var PAYMENTSTATUS_REFUNDED  = '1';
    var PAYMENT_INVOICE = null;

    this.getPaymentInvoice = function(){
        var now = new Date();
        var year = now.getFullYear().toString();
        var month = self.leftZero(now.getMonth() + 1);
        var day = self.leftZero(now.getDate());
        var hour = self.leftZero(now.getHours());
        var minutes = self.leftZero(now.getMinutes());
        var seconds = self.leftZero(now.getSeconds());

        PAYMENT_INVOICE = year + month + day + hour + minutes + seconds;

        return PAYMENT_INVOICE;
    };

    this.integrationPayment = function(operatorData, currentRow){
        var params = {
            'paymentType': currentRow.tiporece.IDTIPORECE,
            'paymentValue':parseFloat((currentRow.VRMOVIVEND * 100).toFixed(2)),
            //'paymentValue': (currentRow.VRMOVIVEND.toFixed(2))*1000/10,//Favor não alterar, bug com 55 centavos
            'installmentsNumber': 0
        };

        if(!!window.ZhStoneAutomation) {
            window.changeLoader = self.changeLoader;
            ZhStoneAutomation.initiateApp();
            ZhStoneAutomation.continueApplication(JSON.stringify(params));
        } else {
            window.returnIntegration(self.invalidIntegrationInstance());
        }
    };

    this.leftZero = function(leftZero){
            if(leftZero < 10)
                leftZero = "0" + leftZero;

            return leftZero;
        };

    this.integrationPaymentResult = function(resolve, javaResult){
        var integrationResult = self.formatResponde();
        javaResult = self.handleJavaResult(javaResult);
        ScreenService.closePopup();

        if (javaResult.Status == "APPROVED" || javaResult.Status == "PARTIAL_APPROVED"){
                integrationResult.error = false;
                integrationResult.data = {
                    CDNSUHOSTTEF: javaResult.Arcq,
                    TRANSACTIONID: javaResult.StoneId,
                    NRCONTROLTEF: self.getPaymentInvoice(),
                    CDBANCARTCR: javaResult.Bandeira,
                    PAYMENTCONFIRMATION: PAYMENT_CONFIRMATION,
                    REMOVEALLINTEGRATIONS: REMOVE_ALL_INTEGRATIONS
                };
                ScreenService.restoreDefaultLoadingMessage();
                ScreenService.confirmMessage(
                     'Deseja imprimir a via do cliente?', 'question',
                     function(){
                        ZhStoneAutomation.printTefVoucher(2);
                        resolve(integrationResult);
                     }.bind(this),
                     function(){
                        resolve(integrationResult);
                     }.bind(this)
                );
        } else {
            integrationResult.message = javaResult.message;
            integrationResult.message2 = javaResult.message2;
            ScreenService.restoreDefaultLoadingMessage();
            resolve(integrationResult);
        }

    };

    this.changeLoader = function(action){
        if (action.message == "TRANSACTION_WAITING_CARD"){
            ScreenService.hideLoader();
            var widgetBase = templateManager.container.login || templateManager.containers.auth;
            var sitefWidget = widgetBase.getWidget("sitefPayment");
            var field = sitefWidget.getField("digitalWallets");
            sitefWidget.getField("userInput").isVisible = false;
            sitefWidget.getAction("btnBackStone").isVisible = true;
            sitefWidget.getAction("btnBack").isVisible = false;
            sitefWidget.getAction("btnConfirm").isVisible = false;
            sitefWidget.getAction("btnConfirmStone").isVisible = false;
            field.isVisible = false;
            self.setLabel("Stone");

            ScreenService.openPopup(sitefWidget).then(function() {
                self.configureWindowFunctions();
                self.setMessage("Aproxime, insira ou passe o cartão");
            }.bind(this));

        } else if (action.message == "TRANSACTION_SENDING"){
            ScreenService.closePopup();
            ScreenService.changeLoadingMessage("Enviando Transação");
        } else if (action.message == "TRANSACTION_REMOVE_CARD"){
            ScreenService.closePopup();
            ScreenService.changeLoadingMessage("Retire o cartão");
        }
    };

    this.showMenuDigitalCard = function (menuOptions) {
        var widgetBase = templateManager.container.login || templateManager.containers.auth;
        var widget = widgetBase.getWidget("sitefPayment");
        var field = widget.getField("voucherOptions");
        var paymentMenuWidget = templateManager.containers.paymentMenu.getWidget("paymentPopup");
        field.clearValue();
        menuOptions = menuOptions.options.split(";");
        paymentMenuWidget.currentRow.voucherOptions = menuOptions;
        var filteredNotEmptyMenuOptions = menuOptions.filter(Boolean);
        var dataSourceFormatedOptions = Array();

        self.setLabel("Voucher");
        self.setMessage("Selecione o tipo de pagamento");

        for (var i in filteredNotEmptyMenuOptions){
            dataSourceFormatedOptions.push({voucherOptions: filteredNotEmptyMenuOptions[i]});
        }

        field.dataSource.data = dataSourceFormatedOptions;
        field.widget.activate();
        field.isVisible = true;
    };

    this.continueAsDigitalWallet = function(buffer) {
        var paymentMenuWidget = templateManager.containers.paymentMenu.getWidget("paymentPopup");
        var tipo = paymentMenuWidget.currentRow.selectedDigitalWallet.toString();
        
        if(tipo == "ALIMENTACAO"){
            tipo = 1;
        } else if(tipo == "REFEICAO"){
            tipo = 2;
        }

        ZhStoneAutomation.continuePaymentVoucher(tipo);

    };

    this.setDigitalWallet = function(field) {
        var paymentMenuWidget = templateManager.containers.paymentMenu.getWidget("paymentPopup");
        self.setMessage("Clique em confirmar para continuar a transação");
        field.widget.currentRow.userInput = field.value().replace(/[^0-9]/g,'');
        paymentMenuWidget.currentRow.selectedDigitalWallet = field.widget.currentRow.userInput;
        field.widget.getAction("btnConfirmStone").isVisible = true;
    };

    this.abortStoneProcess = function(){
        ZhStoneAutomation.abort();
    };

    this.setLabel = function(label) {
        var widgetBase = templateManager.container.login || templateManager.containers.auth;
        widgetBase.getWidget("sitefPayment").label = label;
    };

    this.setMessage = function(message) {
        var widgetBase = templateManager.container.login || templateManager.containers.auth;
        widgetBase.getWidget("sitefPayment").getField("userInterface").value(_.toUpper(message));
    };

    this.configureWindowFunctions = function() {
        window.hideLoader = ScreenService.hideLoader;
        window.showLoader = ScreenService.showLoader;
        window.setMessage = self.changeLoader;
        window.setLabel = self.setLabel;
        window.appendMessage = self.appendMessage;
        window.showConfigureEpayModule = self.showConfigureEpayModule;
        window.promptBoolean = self.promptBoolean;
        window.promptCommand = self.promptCommand;
        window.hideUserInterfaces = self.hideUserInterfaces;
        window.showCancelButton = self.showCancelButton;
        window.showQrCode = self.showQrCode;
        window.hideQrCode = self.hideQrCode;
        window.showMenuDigitalCard = self.showMenuDigitalCard;
    };

    // o cancelamento da stone é o próprio estorno
    this.cancelIntegration = function(tiporeceData){
        self.reversalIntegration(tiporeceData);
    };

    this.cancelIntegrationResult = function(resolve, javaResult){
        self.reversalIntegrationResult(resolve, javaResult);
    };

    this.reversalIntegration = function(tiporeceData){
        if(!!window.ZhStoneAutomation) {
            ZhStoneAutomation.initiateApp();
            ZhStoneAutomation.cancelaTransacao(tiporeceData.TRANSACTIONID);
        } else {
            window.returnIntegration(self.invalidIntegrationInstance());
        }
    };

    this.reversalIntegrationResult = function(resolve, javaResult){
        var integrationResult = self.formatResponde();

        if (javaResult.statusCode === "PAYMENTSTATUS_REFUNDED"){
            ScreenService.confirmMessage(
                'Deseja imprimir a via do cliente?', 'question',
                function(){
                    ZhStoneAutomation.printRefundTefVoucher(2, ZhStoneAutomation.buscaTransacao(javaResult.stoneId));
                    integrationResult.error = false;
                    resolve(integrationResult);
                }.bind(this),
                function(){
                    integrationResult.error = false;
                    resolve(integrationResult);
                }.bind(this)
            );

        } else {
            integrationResult.message = javaResult.message;
            resolve(integrationResult);
        }
    };

    this.completeIntegration = function(){
        return true;
    };

    this.completeIntegrationResult = function(resolve, javaResult){
        return true;
    };

    this.formatResponde = function(){
        return {
            error: true,
            message: '',
            data: {}
        };
    };

    this.invalidIntegrationInstance = function(){
        return {
            statusCode: '2',
            message: MESSAGE_INTEGRATION_FAIL
        };
    };

    this.handleJavaResult = function(javaResult){
        if(typeof(javaResult) === 'string')
            javaResult = JSON.parse(javaResult);

        return javaResult;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('IntegrationStone', IntegrationStone);
});