function WindowService(ScreenService, ConfigIpRepository, Query, LogGeraLog) {
	var self = this;

	const WINDOWS = {
		// smart promo screens
		PROMO_SCREEN: "smartPromo",
		SUBPROMO_SCREEN: "subPromo",
		CHECK_PROMO_SCREEN: "checkPromo",

		// account screens
		PAYMENT_SCREEN: "accountPaymentNamed",
		ADVANCE_PAYMENT_SCREEN: "accountAdvancePaymentNamed",
		PAYMENT_TYPES_SCREEN: "paymentMenu",
		ADVANCE_PAYMENT_TYPES_SCREEN: "advancePaymentMenu",
		CLOSE_ACCOUNT_SCREEN: "closeAccount",
		SPLIT_PRODUCTS_SCREEN: "splitProducts",
		DELAYED_PRODUCTS_SCREEN: "delayedProducts",
		CANCEL_PRODUCT_SCREEN: "cancelProductComanda",
		CANCEL_PRODUCT_SCREEN2: "cancelProductMesa",
		TRANSFERS_SCREEN: "transfers",
		TRANSACTIONS_SCREEN: "transactions",
		ACCOUNT_DETAILS_SCREEN: "accountDetails",
		CHECK_ORDER_SCREEN: "checkOrderPos",
		CHECK_ORDER_SCREEN2: "checkOrderGrp",
		SEND_MESSAGE_SCREEN: "sendMessage",
		MENU_SCREEN: "menu",

		// tables screens
		TABLES_SCREEN: "tables",
		GROUP_TABLE_SCREEN: "groupTable",
		LOGIN_SCREEN: "login",
		LOGIN_FILIAL_SCREEN: "loginAuth",

		// bill screens
		BILLS_SCREEN: "bills",
		PARENT_DASHBOARD_SCREEN: "parentDashboard",
		ACCOUNT_DETAILS_SCREEN_BILL: "accountDetailsBill",
		BILL_LOGIN_SCREEN: "billLogin",

		// order screens
		ORDER_CHECK_ORDER_SCREEN: "orderCheckOrder",
		ORDER_TEMPORARY_SCREEN: "orderTemp",
		ORDER_LOGIN_SCREEN: "orderLogin",
		ORDER_ACCESS_SCREEN: "orderAccess",
		ORDER_MENU_SCREEN: "orderMenu",
		NEW_CONSUMER_SCREEN: "newConsumer",
        COMPRE_GANHE_SCREEN: "compreGanhe",

		// register screens
		OPEN_REGISTER_SCREEN: "openRegister",
		CLOSE_REGISTER_SCREEN: "closeRegister",

		// delivery screens
		DELIVERY_ORDERS_SCREEN: "delivery",
		DELIVERY_ORDER_DETAIL_SCREEN: "orderDelivery"
	};

	this.openWindow = function(newWindow) {
		return ScreenService.openWindow(WINDOWS[newWindow]);
	}.bind(this);

	this.logGeraLog = function(TEXTO,PASTA, DATA) {
		return new Promise(function(resolve){
			if(!window.operatorData || !window.NRORG || true){
				resolve(false);
				return;
			}
			DATA=DATA||getDataHora();
			var query = Query.build()
				.where('NRORG')   .equals((window.NRORG||''))
				.where('CDFILIAL').equals((window.CDFILIAL||''))
				.where('CDCAIXA') .equals((window.CDCAIXA||''))
				.where('TEXTO')   .equals((TEXTO||''))
				.where('DATA')    .equals((DATA||''))
				.where('PASTA')   .equals((PASTA||''));
			LogGeraLog.download(query).then(function(respostalogGeraLog){
				if(respostalogGeraLog){
					if(respostalogGeraLog[0]){
						if((respostalogGeraLog[0]).toLowerCase()=='ok'){
							resolve(true);
							return;
						}
					}
				}
				resolve(false);
			},function(){
				resolve(false);
			});
		});
	};

	this.logGeraLogForaDoZeedhi = function(texto,pasta, data) {
		return new Promise(function(resolve){
			ConfigIpRepository.findOne().then(function (ipInfo) {
				try {
					if(!ipInfo||!projectConfig){ resolve(true); return;}
					if(!ipInfo.ipForBack||!projectConfig.serviceUrl){ resolve(true); return;}
					stBackend = projectConfig.serviceUrl.split("/");
					stBackend.pop();
					stBackend = stBackend.join("/");
					stBackend = stBackend+"/..";
					
					pasta = pasta||"";
					if(pasta != "SEMCONEXAO"){
						if(ipInfo.ipForBack.includes("teknisa.cloud")){
							if(
								window.location.href.indexOf('paymentMenu')<0 &&
								window.location.href.indexOf('saleCancel')<0 &&
								window.location.href.indexOf('generalFunctions')<0 &&
								window.location.href.indexOf('closeRegister')<0					
							){
								// só faz o salvamento do log caso esteja dentro de alguma dessas telas
								resolve(true);
								return;
							}
						}
					}
					var arrUrl = ipInfo.ipForBack.split('/');
					//verifica se o nome odhen-pos ou odhen-pos/main esta se repetindo
					var arrServiceUrl = stBackend.split('/');
					if(arrUrl[arrUrl.length-1].toLowerCase() == arrServiceUrl[2].toLowerCase() && arrUrl[arrUrl.length-2].toLowerCase() == arrServiceUrl[1].toLowerCase()){
						arrServiceUrl.splice(1,2);
					} else if(arrUrl[arrUrl.length-1].toLowerCase() == arrServiceUrl[1].toLowerCase()){
						arrServiceUrl.splice(1,1);
					}
					stBackend = arrServiceUrl.join('/');
					data=data||getDataHora();
					$.post(
						ipInfo.ipForBack+"/"+stBackend+"/src/Util/Log.php",
						{
							"CDFILIAL":(window.CDFILIAL||''),
							"CDCAIXA" :(window.CDCAIXA||''),
							"NRORG"   :(window.NRORG||''),
							"TEXTO"   :(texto||''),
							"PASTA"	  :(pasta||''),
							"DATA"    :(data||'')
						},
						function(respostalogGeraLogForaDoZeedhi){
							if(respostalogGeraLogForaDoZeedhi){
								if(respostalogGeraLogForaDoZeedhi.toLowerCase()=='ok' || respostalogGeraLogForaDoZeedhi.toLowerCase().indexOf("Erro ao salvar o arquivo de log".toLowerCase())>=0 ){
									resolve(true);
									return;
								}
							}
							resolve(false);
						}
					).fail(function(){
						resolve(false);
					});
				}catch(e){ }
			});
		});
	};

	this.arrUltimaMensagem = Array();
	this.log = function(texto,pasta,idEnvio){
		return new Promise(function (resolve, reject) {
			try {
				idEnvio=idEnvio||null;
				texto=""+(texto||'');
				texto = texto.substring(0,4000);
				if(!pasta){ pasta=""; }
				if(!idEnvio){
					idEnvio = getDataHora();
				}
				var ultimaMensagem=null;
				var diffEmSegundos=null;
				for (var i=0;i < self.arrUltimaMensagem.length;i++){
					// para evitar loop ou envio desnecessário de mensagens, verifica se a mensagem é igual a mensagem anterior
					ultimaMensagem = self.arrUltimaMensagem[i];
					if(ultimaMensagem){
						var iguais = (ultimaMensagem.TEXTO == texto || ultimaMensagem.TEXTO.toLowerCase() == texto.toLowerCase());
						if(!iguais){
							if(texto.indexOf(' --- ')>0 || ultimaMensagem.TEXTO.indexOf(' --- ')>0){
								// verifica se sao iguais mesmo apos retirar o prefixo de semconexao
								iguais = texto.substr(texto.indexOf(' --- ')<0?0:texto.indexOf(' --- ')) == ultimaMensagem.TEXTO.substr(ultimaMensagem.TEXTO.indexOf(' --- ')<0?0:ultimaMensagem.TEXTO.indexOf(' --- '));
							}
						}
						if( iguais ) {
							diffEmSegundos = Math.floor((Math.abs(new Date() - ultimaMensagem.DATA)) / 1000 );
							self.arrUltimaMensagem[i].DATA = new Date();
							if(diffEmSegundos<=2) {
								resolve(true);
								return;
							}
						}
					}
				}
				self.arrUltimaMensagem.push({ TEXTO:texto,PASTA:pasta,DATA: new Date()});
				if(Math.floor((Math.abs(new Date() - self.arrUltimaMensagem[0].DATA)) / 1000 ) > 5 ){
					//remove a mensagem caso tenha mais de 5 segundos
					while ( 1 ){
						ultimaMensagem = self.arrUltimaMensagem[0]||null;
						if(ultimaMensagem){
							diffEmSegundos = Math.floor((Math.abs(new Date() - ultimaMensagem.DATA)) / 1000 );
							if(diffEmSegundos>5) {
								self.arrUltimaMensagem.shift();
							} else {
								break;
							}
						} else {
							break;
						}
					}
				}
				self.logGeraLog(texto,pasta,idEnvio).then(function(respostalogGeraLog){
					if(respostalogGeraLog){
						return respostalogGeraLog;
					} else {
						// se o envio pela rota do zeedhi der erro, tenta pela url por fora
						return self.logGeraLogForaDoZeedhi(texto,pasta,idEnvio);
					}
				}).then(function(retornoLog){
					if(retornoLog){
						self.filaLog=self.filaLog||{};
						if(self.filaLog[idEnvio]){
							self.filaLog[idEnvio] = null;
							delete self.filaLog[idEnvio];
						}
						setTimeout(function(){
							self.processaFilaLog(true);
						},(!idEnvio)?0:1000);
					} else {
						// se der erro adiciona o comando a fila de semconexao
						self.filaLog=self.filaLog||{};
						if(!self.filaLog[idEnvio]){
							self.filaLog[idEnvio] = {"texto":(texto||'')};
						}
						self.processaFilaLog();
					}
				});
			}catch(e){ }
			resolve();
		});
	};

	window.log = self.log;

	this.processaFilaLog=function(todos){
		if(!self.processandoFila){
			self.processandoFila = true;
			setTimeout(function(){
				self.filaLog=self.filaLog||{};
				for (var chave in self.filaLog) {
					if (self.filaLog.hasOwnProperty(chave)) {
						self.log(chave+" --- "+self.filaLog[chave].texto,"SEMCONEXAO",chave);
						if(!todos){
							break;
						}
					}
				}
				self.processandoFila = false;
			},todos?0:30000);
		}
	};

	this.getDataHora = function(){
		var agora = new Date();
		function pad_(texto,n) {
			texto = texto||"";
			n=n||texto.length;
			var complemento = "0";
			for (var index = 0; index < n; index++) {
				complemento+="0";
			}
			return (complemento + texto ).slice(-n);
		}
	
		var Ano = pad_(agora.toLocaleString('pt-BR',{ timeZone:'America/Bahia', hour12: false, year: 'numeric'}),4);
		var Mes = pad_(agora.toLocaleString('pt-BR',{ timeZone:'America/Bahia', hour12: false, month: '2-digit'}),2);
		var Dia = pad_(agora.toLocaleString('pt-BR',{ timeZone:'America/Bahia', hour12: false, day: '2-digit'}),2);
		var Hora = pad_(agora.toLocaleString('pt-BR',{ timeZone:'America/Bahia', hour12: false, hour: '2-digit'}),2);
		var Min = pad_(agora.toLocaleString('pt-BR',{ timeZone:'America/Bahia', hour12: false, minute: '2-digit'}),2);
		var Seg = pad_(agora.toLocaleString('pt-BR',{ timeZone:'America/Bahia', hour12: false, second: '2-digit'}),2);
		var Mili = pad_(agora.getMilliseconds(),3);

		var DataHora = Ano+"_"+Mes+"_"+Dia+"_"+Hora+"_"+Min+"_"+Seg+"-"+Mili;

		return DataHora;
	};

	window.getDataHora = self.getDataHora;

	ScreenService.showCustomDialogTemp = ScreenService.showCustomDialog;
	ScreenService.showCustomDialog = function(){
		//Caso o loader esteja com 4 pontos indica que ele será finalizado quando uma mensagem for exibida.
		if(window.ApplicationContext.templateManager.loadingMessage=="Aguarde...."){
			ScreenService.changeLoadingMessage("Aguarde...");
			ScreenService.restoreDefaultLoadingMessage();
			ScreenService.hideLoader();
		}
		self.log((arguments[0]||''),"");
		//return  ScreenService.showCustomDialogTemp(...args);
		return ScreenService.showCustomDialogTemp.apply(ScreenService, arguments);
	};

	ScreenService.notificationMessageTemp = ScreenService.notificationMessage;
	ScreenService.notificationMessage = function(){
		self.log((arguments[0]||''),"");
		//return  ScreenService.notificationMessageTemp(...args);
		return ScreenService.notificationMessageTemp.apply(ScreenService, arguments);
	};

	this.getInstanciaTEF = function(){
		var instanciaTEF = null;
		if(!!window.ZhGetNetAutomation) {
			instanciaTEF = window.ZhGetNetAutomation; // Getnet
		} else if(!!window.ZhADX8000Automation) {
			instanciaTEF = window.ZhADX8000Automation;
		} else if(!!window.ZhCapptaAutomation) { //Cappta
			instanciaTEF = window.ZhCapptaAutomation;
		} else if(!!window.ZhCieloAutomation) { // Cielo
			instanciaTEF = window.ZhCieloAutomation;
		} else if(!!window.zhSafraPayAutomation) { //SafraPay
			instanciaTEF = window.zhSafraPayAutomation;
		} else if(!!window.ZhStoneAutomation) { //Stone
			instanciaTEF = window.ZhStoneAutomation;
		} else if (window.ZhRedeAutomation){ // Rede
			instanciaTEF = window.ZhRedeAutomation;
		} else if (window.ZhGPOS720Automation){ // 
			instanciaTEF = window.ZhGPOS720Automation;
		} else if(!!window.cordova){
			if(!!window.cordova.plugins.GertecRede) { // Rede
				instanciaTEF = window.cordova.plugins.GertecRede;
			} else if(!!window.cordova.plugins.IntegrationService) {
				instanciaTEF = window.cordova.plugins.IntegrationService;
			} else if(!!window.cordova.plugins.GertecSitef) { //Sitef
				instanciaTEF = window.cordova.plugins.GertecSitef;
			}
		}
		return instanciaTEF;
	};
	
	this.validaModeloIMP = function(IDMODEIMPRES){
		//validar se existe a instancia da lib de impressão android
		if(
			(IDMODEIMPRES == '25' && existe(window,"cordova.plugins.GertecPrinter")) ||
			(IDMODEIMPRES == '25' && existe(window,"ZhGertecPrinter")) ||
			(IDMODEIMPRES == '26' && !!window.RedePoyntPrinterJSInterface) ||
			(IDMODEIMPRES == '27' && !!window.ZhCieloAutomation) ||
			(IDMODEIMPRES == '27' && !!window.ZhCieloPrinter) ||
			(IDMODEIMPRES == '28') ||
			(IDMODEIMPRES == '38' && existe(window,"ZhNewlandPrinter")) ||
			(IDMODEIMPRES == '38' && existe(window,"cordova.plugins.IntegrationService")) ||
			(IDMODEIMPRES == '39' && existe(window,"cordova.plugins.IntegrationService")) ||
			(IDMODEIMPRES == '40' && !!window.ZhStoneAutomation) ||
			(IDMODEIMPRES == '40' && !!window.ZhStonePrinter) ||
			(IDMODEIMPRES == '47' && !!window.ZhMiniPDVPrinter) ||
			(IDMODEIMPRES == '48' && !!window.ADX8000Printer) ||
			(IDMODEIMPRES == '49' && !!window.ZhSafraPayPrinter) ||
			(IDMODEIMPRES == '50' && !!window.ZhPositivoPrinter) ||
			(IDMODEIMPRES == '51' && !!window.GPOS720Printer)
		){
			return true;
			}
		return null;
	};
}


//Modos Waiter
var modosWaiter = {
	mesa: { codigo: "M", nome: "Mesa" },
	comanda: { codigo: "C", nome: "Comanda" },
	order: { codigo: "O", nome: "Order" },
	balcao: { codigo: "B", nome: "Balcão" }
};

var modosCaixa = {
	POS: { nome: "Venda balcão", modos: ["B"] },
	CMD: { nome: "Comanda + venda balcão", modos: ["C", "B"] },
	RES: { nome: "Restaurante + venda balcão", modos: ["M", "B"] },
	FOS: { nome: "Venda balcão + comanda + restaurante", modos: ["M", "B", "C"] },
	PKC: { nome: "Pocket comanda", modos: ["C"] },
	PKR: { nome: "Pocket restaurante", modos: ["M"] },
	TAA: { nome: "Terminal de auto atendimento", modos: [] },
	FKB: { nome: "Microterminal", modos: [] },
	EVB: { nome: "Delivery", modos: ["D"] },
	CTL: { nome: "Controle de Produção", modos: [] },
	CSE: { nome: "Controde de Saída e Entrada de Pedidos", modos: [] }
};

Configuration(function(ContextRegister) {
	ContextRegister.register("WindowService", WindowService);
});
